#pragma once

#include "gui.h"
#include "framebuffer.h"
#include "tmesh.h"
#include "ppc.h"

class Scene {
public:
  GUI *gui;
  FrameBuffer *fb, *text;
  PPC *ppc, *ppc2;
  TMesh *tmesh, *tmesh2, *tmesh3;
  float rstep;
  float tstep;
  Scene();
  void Render();
  void DBG();
  void SaveView();
  void LoadView();
  FrameBuffer *ims[3];
  PPC *imppcs[3];
  int currImage;
  FrameBuffer *canvas;
  PPC *canvasppc;
  void RenderCanvas();
  void PanoramaSetup();
  void LoadConstructionImages();
  void NextPair();
  void SavePPCs();

  // cube map
  FrameBuffer *faces[6];
  PPC *faceppcs[6];
  void SaveCubeMap();
  void BuildPanorama(FrameBuffer **cims, PPC **cimppcs, int cimN);
  void UpdateImpostor(TMesh *reflector, TMesh *diffuse);
  PPC *impPPC;
  TMesh *impQuad;
};

extern Scene *scene;
