#pragma once

#include <ostream>
#include <istream>

using namespace std;

class M3x3;

class V3 {
  float xyz[3];
public:
  V3() {};
  V3(float x, float y, float z);
  V3 operator+(V3 v1);
  V3 operator-(V3 v1);
  V3 operator/(float sc);
  V3 operator*(float sc);
  float operator*(V3 v1);
  V3 operator^(V3 v1);
  float& operator[](int i);
  friend ostream& operator<<(ostream& ostr, V3 v);
  friend istream& operator>>(istream& istr, V3& v);
  V3(unsigned int color);
  unsigned int Color();
  float Length();
  V3 RotateThisVectorAboutAxis(V3 axis, float rstep);
  M3x3 MakeCSThisY();
  V3 Normalized();
  V3 Reflect(V3 v);
};